##################################
### Voice.tcl                  ###
### Version 1.1                ###
### By Wcc                     ###
### wcc@techmonkeys.org        ###
### http://www.dawgtcl.com:81/ ###
### EFnet #|DAWG|Tcl           ###
##################################

############################################################################
### Copyright  2000 - 2002 |DAWG| Scripting Group. All rights reserved. ###
############################################################################

#######################################################################
## This script automatically voices users that join +voice channels. ##
## If an op devoices a user, the bot will not voice the user again   ##
## until X minutes have passed. At that time, the user can rejoin    ##
## and will again be voiced by the bot.                              ##
##                                                                   ##
## NOTE: This will not work if the channel is +autovoice; this       ##
## replaces +autovoice.                                              ##
#######################################################################

##############
## COMMANDS ##
#########################################################
## DCC ## .chanset <channel> +/-voice                  ##
######### Enables or disables autovoice for a channel. ##
#########################################################

##########################################################
## Just load the script, edit the settings, and rehash. ##
##########################################################

##########################################################################
# How long should the bot wait (in minutes) before voicing a user again? #
##########################################################################

set voice_setting(time) "15"

####################
# Code begins here #
####################

if {![string match 1.6.* $version]} { putlog "\002VOICE:\002 \002WARNING:\002 This script is intended to run on eggdrop 1.6.x or later." }
if {[info tclversion] < 8.2} { putlog "\002VOICE:\002 \002WARNING:\002 This script is intended to run on Tcl Version 8.2 or later." }

setudef flag voice

bind join v|v * voice_voicejoin
bind mode - "% -v" voice_time

proc voice_voicejoin {nick uhost hand chan} {
	global voice_setting
	if {[lsearch -exact [channel info $chan] +voice] != -1 && ![matchattr $hand |V $chan]} { putserv "MODE $chan +v $nick" }
}
proc voice_time {nick uhost hand chan devoice devoiced} {
	global voice_setting
	set devoiced [nick2hand $devoiced]
	if {[lsearch -exact [channel info $chan] +voice] != -1 && [matchattr $devoiced v|v $chan] && ![matchattr $devoiced |V $chan]} {
		chattr $devoiced |+V $chan
		timer $voice_setting(time) [list chattr $devoiced |-V $chan]
	}
}
putlog "\002VOICE:\002 Voice.tcl Version 1.1 by Wcc is loaded."